//
//
//      Copyright (c) ClearSpeed Technology plc 2000,2002,2006
//      All rights reserved.
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk. Permission to use or copy this
// software for any purpose is hereby granted without fee, provided the
// above notices are retained on all copies. Permission to modify the code
// and to distribute modified code is granted, provided the above notices
// are retained, and a notice that the code was modified is included with
// the above copyright notice.
//
// Compile with a command line such as the following:
// gcc -lm -lg2c -lpthread dgemmtest.c /opt/clearspeed/csx600_m512_le/lib/libblas_cs.so
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern void dgemm_(char *transa, char *transb, int *m, int *n, int *k, double *alpha, double *a,
int *lda, double *b, int *ldb, double *beta, double *c, int *ldc, int transa_len, int transb_len);

int main(int argc, char *argv[])
{
  double *a, *b, *c, alpha, beta;
  size_t m,n,k;
  struct timeval start, end;

  if (argc<4)
    {
      printf("Usage: %s m n k to call a dgemm with size m,n,k\n", argv[0]);
      return 0;
    }

  m=atoi(argv[1]);
  n=atoi(argv[2]);
  k=atoi(argv[3]);

  a=(double*)malloc(m*k*sizeof(double));
  b=(double*)malloc(n*k*sizeof(double));
  c=(double*)malloc(n*m*sizeof(double));

  memset(a, 0, m*k*sizeof(double));
  memset(b, 0, n*k*sizeof(double));
  memset(c, 0, m*n*sizeof(double));

  alpha=2.75; beta=4.21;

  dgemm_("T", "T", &m, &n, &k, &alpha, a, &k, b, &n, &beta, c, &m, 1, 1);

  free (c);
  free (b);
  free (a);

  return 0;
}