/*
 *
 *     Copyright (c) 2006, ClearSpeed Technology plc. All rights reserved.
 *
 * This material is provided "as is", with absolutely no warranty expressed or
 * implied. Any use is at your own risk. Permission to use or copy this software
 * for any purpose is hereby granted without fee, provided the above notices are
 * retained on all copies. Permission to modify the code and to distribute
 * modified code is granted, provided the above notices are retained, and a
 * notice that the code was modified is included with the above copyright notice.
 *
 */

#ifndef _CSDFT_SUPPORT_H
#define _CSDFT_SUPPORT_H

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

#include "csdft.h"

struct CSAPIState ;

/*============================================================================*/
/* Prototypes for support routines which allow retrieval of board state       */
/*============================================================================*/

CSDftStatus CSDFT_get_csapi_handle          ( struct CSAPIState  **handle ) ;

CSDftStatus CSDFT_get_csapi_handle_board    ( struct CSAPIState  **handle,
                                              unsigned int  board_instance ) ;

CSDftStatus CSDFT_get_symbol_value          ( const char        *symbol,
                                              unsigned int      *symbol_address,
                                              unsigned int       board_instance,
                                              unsigned int       processor_instance ) ;


/*============================================================================*/
/* Prototype for a integer log to the base 2 routine                          */
/*============================================================================*/

unsigned int CSDFT_ilog2                   ( unsigned int n ) ;

/*============================================================================*/
/* Prototypes for bitreversal and optimal/natural order conversion routines   */
/*============================================================================*/

CSDftStatus CSDFT_bitreverse_1D_c          ( void        *data,
                                             unsigned int x_size,
                                             unsigned int number_of_arrays ) ;

CSDftStatus CSDFT_bitreverse_1D_z          ( void        *data,
                                             unsigned int x_size,
                                             unsigned int number_of_arrays ) ;

CSDftStatus CSDFT_optimal_to_natural_2D_c  ( void        *data,
                                             unsigned int x_size,
                                             unsigned int y_size,
                                             unsigned int number_of_arrays ) ;

CSDftStatus CSDFT_optimal_to_natural_2D_z  ( void        *data,
                                             unsigned int x_size,
                                             unsigned int y_size,
                                             unsigned int number_of_arrays ) ;

CSDftStatus CSDFT_natural_to_optimal_2D_c  ( void        *data,
                                             unsigned int x_size,
                                             unsigned int y_size,
                                             unsigned int number_of_arrays ) ;

CSDftStatus CSDFT_natural_to_optimal_2D_z  ( void        *data,
                                             unsigned int x_size,
                                             unsigned int y_size,
                                             unsigned int number_of_arrays ) ;


#ifdef __cplusplus
}  /* extern "C" */
#endif /* __cplusplus */

#endif /* CSDFT_SUPPORT_H */

