
/*
 * BEGIN COPYRIGHT MESSAGE
 *
 *	Copyright  (c)  ClearSpeed Technology plc 1997-2006.
 *	All rights reserved.
 *
 * The following constitutes CONFIDENTIAL & PROPRIETARY SOURCE CODE of
 * ClearSpeed Technology plc and the contents of this file may not be: disclosed to any
 * third party; copied; or duplicated, whether in whole or in part, without
 * the express written permission of a company Executive Director of
 * ClearSpeed Technology plc.
 *
 * END COPYRIGHT MESSAGE
 */

// the endianness conversion routines

/*! \file

  This contains common types which are used across multiple platform
  Currently only supports large integer values

*/
#ifndef _CROSSPLATFORM_TYPES_H_
#define _CROSSPLATFORM_TYPES_H_

#ifdef __cplusplus
namespace CrossPlatform {
#endif

#if (defined(WIN32) || defined(_WIN32))
typedef unsigned __int64 uint64;
typedef unsigned int uint32;
typedef unsigned short uint16;

typedef __int64 int64;
typedef int int32;
typedef short int16;

#define CONSTUINT64(N) (N ## Ui64)
#define CONSTINT64(N) (N ## i64)

#endif

#ifdef __sun
typedef unsigned long long uint64;
typedef unsigned int uint32;
typedef unsigned short uint16;

typedef long long int64;
typedef int int32;
typedef short int16;

// Because Gnu needs ULL / LL suffix on long long constants:
#define CONSTUINT64(N) (N ## ULL)
#define CONSTINT64(N) (N ## LL)

#endif    
    
#if defined(linux) || defined(__DJGPP__) || defined(__APPLE__)
typedef unsigned long long uint64;
typedef unsigned int uint32;
typedef unsigned short uint16;

typedef long long int64;
typedef int int32;
typedef short int16;

// Because Gnu needs ULL / LL suffix on long long constants:
#define CONSTUINT64(N) (N ## ULL)
#define CONSTINT64(N) (N ## LL)

#endif

#ifdef __cplusplus
};
#endif

#endif







